//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform highp mat4 worldMatrix;
uniform highp mat4 worldViewProjMatrix;

#ifdef DUAL_PARABOLOID_PROJECTION
uniform highp mat4 worldViewMatrix;
#endif

#ifdef AMBIENT_MAP
uniform highp mat4 ambientMapVPMatrix;
#endif

#ifdef DUAL_PARABOLOID_PROJECTION
uniform lowp float cameraFar;
#endif

uniform lowp vec2 DiffuseMapUVScale;
uniform lowp vec2 DiffuseMapUVOffset;

attribute vec4 inPos;
attribute vec4 inNormal;
attribute vec2 inUV0;

varying highp vec3 vNormal;

varying highp vec3 vLightDir;
varying highp vec2 vUV0;

#ifdef AMBIENT_MAP
varying lowp vec2 vPosAmbientMapSpace;
#endif

#ifdef DUAL_PARABOLOID_PROJECTION
#include "paraboloid_project.glsl"
#endif

void main()
{	
	highp vec4 posOS = vec4( inPos.xyz, 1.0 );
	highp vec4 posWS = worldMatrix * posOS;
	
	vNormal = vec3( worldMatrix * vec4( inNormal.xyz, 0.0 ) );
	
	vUV0 = inUV0 * DiffuseMapUVScale + DiffuseMapUVOffset;
	
#ifdef AMBIENT_MAP
	vPosAmbientMapSpace = vec2( ambientMapVPMatrix * posWS );
#endif
	
#ifndef DUAL_PARABOLOID_PROJECTION
	gl_Position = worldViewProjMatrix * posOS;
#else
	gl_Position = ParaboloidProject( worldViewMatrix * posOS, cameraFar );
#endif
}