//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform lowp float ColorScale;
uniform lowp float AlphaScale;
uniform lowp float AmbientInfluence;
uniform lowp float MaxDiffuse;
uniform lowp vec4 TintColor;

uniform lowp vec3 lightDiffuse[MAX_LIGHTS];
uniform lowp vec3 lightPos[MAX_LIGHTS];

uniform lowp vec3 lightAmbient[MAX_LIGHTS];

#ifdef USE_FOG
uniform mediump vec4 fogColor;
uniform lowp float FogInfluence;
#endif

#ifdef ADDITIONAL_COLOR
uniform lowp vec3 AdditionalColor;
#endif

uniform sampler2D diffuseMap;

#ifdef USE_SELF_ILLUM_MAP
uniform sampler2D specularGlossSelfIllumMap;
#endif

varying highp vec3 vNormal;

varying highp vec2 vUV0;

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

void main()
{

		lowp vec4 diffuseCol = jetAlphaTexture2D( diffuseMap, vUV0 ) * TintColor;

#ifdef USE_SELF_ILLUM_MAP
	lowp vec4 diffuseTexCol = diffuseCol;
#endif

	highp vec3 normal = normalize( vNormal );
	
	lowp vec3 lightDir = normalize( lightPos[0] );
	lowp float NdotL = dot( normal, lightDir );
	
	lowp float diffuseIntensity = max( NdotL, 0.0 );

	lowp vec3 lightAmb = lightAmbient[0];

	diffuseIntensity *= MaxDiffuse;
	lowp float lightDiffuseFactor = mix( 1.0, diffuseIntensity, AmbientInfluence );
	
	lowp vec3 color = ( diffuseCol.rgb * mix( lightAmb, lightDiffuse[0], lightDiffuseFactor ) ) * ColorScale;
	
#ifdef USE_SELF_ILLUM_MAP
	lowp vec3 specGlossSi = texture2D( specularGlossSelfIllumMap, vUV0 ).rgb;
#endif
	
#ifdef USE_SELF_ILLUM_MAP
	color = mix( color, diffuseTexCol.rgb, specGlossSi.b );
#endif

#ifdef ADDITIONAL_COLOR
	color += AdditionalColor.rgb;
#endif

#ifdef USE_FOG
	color = mix( color, fogColor.rgb, vFogFactor * FogInfluence );
#endif
	
	lowp vec4 finalColor = vec4( color, diffuseCol.a * AlphaScale );
	
	gl_FragColor = finalColor;
}
