//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform lowp float ColorScale;
uniform lowp float AlphaScale;
uniform lowp float AmbientInfluence;
uniform lowp float MaxDiffuse;
uniform lowp vec4 TintColor;

#ifdef ENVIRONMENT_MAPPING
uniform highp mat4 paraboloidViewMatrix;
#endif

uniform lowp vec3 lightDiffuse[MAX_LIGHTS];
uniform lowp vec3 lightPos[MAX_LIGHTS];

#ifndef AMBIENT_MAP
uniform lowp vec3 lightAmbient[MAX_LIGHTS];
#endif

#ifdef USE_FOG
uniform lowp vec4 fogColor;
uniform lowp float FogInfluence;
#endif

#ifdef CHARACTER_LIGHT
uniform lowp float charLightIntensity;
uniform lowp float charLightMinRadius;
uniform lowp float charLightMaxRadius;
uniform lowp vec3 charLightColor;
uniform lowp vec3 charLightPos;
#endif

#ifdef ENVIRONMENT_MAPPING
	
	#ifndef REFLECTANCE_MAP
	uniform lowp float Reflectance;
	#endif

uniform lowp float ReflectionContrast;
#endif

uniform sampler2D diffuseMap;

#ifdef USE_NM
uniform sampler2D normalMap;
#endif

#ifdef AMBIENT_MAP
uniform sampler2D ambientMap;
#endif

#ifdef ENVIRONMENT_MAPPING
uniform sampler2D environmentMap;
#endif

#if defined( ENVIRONMENT_MAPPING ) && defined( REFLECTANCE_MAP )
uniform sampler2D reflectanceMap;
#endif

#ifdef USE_NM
varying highp vec3 vNorm;
varying highp vec3 vTgt;
varying highp vec3 vBitgt;
#else
varying highp vec3 vNormal;
#endif

varying highp vec2 vUV0;

#ifdef ENVIRONMENT_MAPPING
varying highp vec3 vEyeDir;
#endif

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

#ifdef AMBIENT_MAP
varying lowp vec2 vPosAmbientMapSpace;
#endif

#ifdef CHARACTER_LIGHT
varying highp vec3 vPosWS;
#endif

#ifdef CHARACTER_LIGHT
varying highp vec3 vCharLightDir;
#endif

#ifdef ENVIRONMENT_MAPPING
const lowp vec3 k_colorWeights = vec3( 0.2126, 0.7152, 0.0722 );
#endif

#ifdef ENVIRONMENT_MAPPING
#include "paraboloid_project_uv.glsl"
#endif

void main()
{

	lowp vec4 diffuseCol = jetAlphaTexture2D( diffuseMap, vUV0 ) * TintColor;
	
#ifdef USE_NM
	highp vec3 tgt = normalize( vTgt );
	highp vec3 bitgt = normalize( vBitgt );
	highp vec3 norm = normalize( vNorm );
	
	highp vec3 normal = mat3( tgt, bitgt, norm ) * ( texture2D( normalMap, vUV0 ).xyz * 2.0 - 1.0 );
#else
	highp vec3 normal = normalize( vNormal );
#endif
	
	lowp vec3 lightDir = normalize( lightPos[0] );
	lowp float NdotL = dot( normal, lightDir );
	
	lowp float diffuseIntensity = max( NdotL, 0.0 );

#ifdef CHARACTER_LIGHT
	lowp float charLightDist = length( charLightPos - vPosWS );
	lowp vec3 charLightDir = normalize( vCharLightDir );
	lowp float charLightFactor = ( charLightDist - charLightMinRadius ) / ( charLightMaxRadius - charLightMinRadius );
	charLightFactor = 1.0 - clamp( charLightFactor, 0.0, 1.0 );
	
	lowp float charLightNdotL = dot( normal, charLightDir );
	lowp vec3 charLightFinalColor = charLightColor * max( charLightNdotL, 0.0 ) * charLightFactor * charLightIntensity;
#endif

#ifdef AMBIENT_MAP
	lowp vec3 lightAmb = texture2D( ambientMap, vPosAmbientMapSpace ).rgb;
#else
	lowp vec3 lightAmb = lightAmbient[0];
#endif

	diffuseIntensity *= MaxDiffuse;
	lowp float lightDiffuseFactor = mix( 1.0, diffuseIntensity, AmbientInfluence );
	
	lowp vec3 color = ( diffuseCol.rgb * mix( lightAmb, lightDiffuse[0], lightDiffuseFactor ) ) * ColorScale;
	
#ifdef ENVIRONMENT_MAPPING
	lowp vec3 reflectDir = reflect( normalize( -vEyeDir ), normal );
	lowp vec2 reflectUV = ParaboloidProjectUV( vec3( paraboloidViewMatrix * vec4( reflectDir, 0.0 ) ) );
	lowp vec3 envMapCol = texture2D( environmentMap, reflectUV ).rgb;
	lowp float reflectBrightness = dot( envMapCol, k_colorWeights );
	lowp vec3 reflectCol = mix( vec3( reflectBrightness ), envMapCol, ReflectionContrast );
	
	#ifdef REFLECTANCE_MAP
		color = mix( color, reflectCol, texture2D( reflectanceMap, vUV0 ).r );
	#else
		color = mix( color, reflectCol, Reflectance );
	#endif
#endif
	
#ifdef CHARACTER_LIGHT
	color += diffuseCol.rgb * charLightFinalColor;
#endif

#ifdef USE_FOG
	color = mix( color, fogColor.rgb, vFogFactor * FogInfluence );
#endif
	
	lowp vec4 finalColor = vec4( color, diffuseCol.a * AlphaScale );
	
	gl_FragColor = finalColor;
}
