//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform lowp float ColorScale;
uniform lowp float AlphaScale;
uniform lowp float AmbientInfluence;
uniform lowp float MaxDiffuse;
uniform lowp vec4 TintColor;

uniform lowp vec3 lightDiffuse[MAX_LIGHTS];
uniform lowp vec3 lightPos[MAX_LIGHTS];

uniform lowp vec3 lightAmbient[MAX_LIGHTS];

#ifdef USE_FOG
uniform mediump vec4 fogColor;
uniform lowp float FogInfluence;
#endif

#ifdef CHARACTER_LIGHT
uniform lowp float charLightIntensity;
uniform lowp float charLightMinRadius;
uniform lowp float charLightMaxRadius;
uniform lowp vec3 charLightColor;
uniform lowp vec3 charLightPos;
uniform	lowp float CharacterLightValue;
#endif

uniform sampler2D diffuseMap;

#ifdef VC_CHANNEL_BLENDING
uniform sampler2D baseTexture;
uniform sampler2D redFactorTexture;
uniform sampler2D greenFactorTexture;
uniform sampler2D blueFactorTexture;
#endif

varying highp vec3 vNormal;

varying highp vec2 vUV0;

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

#ifdef CHARACTER_LIGHT
	#ifndef USE_LOWP_POSWS
varying highp vec3 vPosWS;
	#else
varying lowp vec3 vPosWS;
	#endif
#endif

#ifdef CHARACTER_LIGHT
varying highp vec3 vCharLightDir;
#endif

#ifdef VC_CHANNEL_BLENDING
varying lowp vec4 vColor;
#endif

void main()
{

	#ifndef VC_CHANNEL_BLENDING
		lowp vec4 diffuseCol = jetAlphaTexture2D( diffuseMap, vUV0 ) * TintColor;
	#else
		lowp vec4 colBase = texture2D( baseTexture, vUV0 );
		lowp vec4 colr = texture2D( redFactorTexture, vUV0 );
		lowp vec4 colg = texture2D( greenFactorTexture, vUV0 );
		lowp vec4 colb = texture2D( blueFactorTexture, vUV0 );
		
		lowp float baseFactor = 1.0 - min( vColor.r + vColor.g + vColor.b, 1.0 );
		lowp vec4 diffuseCol = baseFactor * colBase + colr * vColor.r + colg * vColor.g + colb * vColor.b;
	#endif

	highp vec3 normal = normalize( vNormal );
	
	lowp vec3 lightDir = normalize( lightPos[0] );
	lowp float NdotL = dot( normal, lightDir );
	
	lowp float diffuseIntensity = max( NdotL, 0.0 );

#ifdef CHARACTER_LIGHT
	lowp float charLightDist = length( charLightPos - vPosWS );
	lowp vec3 charLightDir = normalize( vCharLightDir );
	lowp float charLightFactor = ( charLightDist - charLightMinRadius ) / ( charLightMaxRadius - charLightMinRadius );
	charLightFactor = 1.0 - clamp( charLightFactor, 0.0, 1.0 );
	
	lowp float charLightNdotL = dot( normal, charLightDir );
	lowp vec3 charLightFinalColor = charLightColor * max( charLightNdotL, 0.0 ) * charLightFactor * charLightIntensity;
#endif

	lowp vec3 lightAmb = lightAmbient[0];

	diffuseIntensity *= MaxDiffuse;
	lowp float lightDiffuseFactor = mix( 1.0, diffuseIntensity, AmbientInfluence );
	
	lowp vec3 color = ( diffuseCol.rgb * mix( lightAmb, lightDiffuse[0], lightDiffuseFactor ) ) * ColorScale;
	
#ifdef CHARACTER_LIGHT
	color += diffuseCol.rgb * charLightFinalColor * CharacterLightValue;
#endif

#ifdef USE_FOG
	color = mix( color, fogColor.rgb, vFogFactor * FogInfluence );
#endif
	
	lowp vec4 finalColor = vec4( color, diffuseCol.a * AlphaScale );
	
	gl_FragColor = finalColor;
}
