//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform lowp float ColorScale;
uniform lowp float AlphaScale;
uniform lowp float AmbientInfluence;
uniform lowp float MaxDiffuse;
uniform lowp vec4 TintColor;

uniform lowp vec3 lightDiffuse[MAX_LIGHTS];
uniform lowp vec3 lightPos[MAX_LIGHTS];

#ifndef AMBIENT_MAP
uniform lowp vec3 lightAmbient[MAX_LIGHTS];
#endif

#ifdef USE_FOG
uniform lowp vec4 fogColor;
uniform lowp float FogInfluence;
#endif

#ifdef BURNING_MAP
uniform lowp float BurningThreshold;
uniform lowp vec3 FireColor;
#endif

#ifdef RIM_LIGHT
uniform lowp float RimPower;
uniform lowp vec4 RimColor;
#endif

uniform sampler2D diffuseMap;

#ifdef AMBIENT_MAP
uniform sampler2D ambientMap;
#endif

#ifdef USE_SELF_ILLUM_MAP
uniform sampler2D specularGlossSelfIllumMap;
#endif

#ifdef BURNING_MAP
uniform sampler2D burningMap;
#endif

varying highp vec3 vNormal;

varying highp vec2 vUV0;

#ifdef RIM_LIGHT
varying highp vec3 vEyeDir;
#endif

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

#ifdef AMBIENT_MAP
varying lowp vec2 vPosAmbientMapSpace;
#endif

void main()
{
#ifdef BURNING_MAP
	lowp float burningAlpha = texture2D( burningMap, vUV0 ).r;
	if( burningAlpha > BurningThreshold )
		discard;
#endif

	lowp vec4 diffuseCol = jetAlphaTexture2D( diffuseMap, vUV0 ) * TintColor;
	
#ifdef USE_SELF_ILLUM_MAP
	lowp vec4 diffuseTexCol = diffuseCol;
#endif

	highp vec3 normal = normalize( vNormal );
	
	lowp vec3 lightDir = normalize( lightPos[0] );
	lowp float NdotL = dot( normal, lightDir );
	
	lowp float diffuseIntensity = max( NdotL, 0.0 );

#ifdef AMBIENT_MAP
	lowp vec3 lightAmb = texture2D( ambientMap, vPosAmbientMapSpace ).rgb;
#else
	lowp vec3 lightAmb = lightAmbient[0];
#endif

	diffuseIntensity *= MaxDiffuse;
	lowp float lightDiffuseFactor = mix( 1.0, diffuseIntensity, AmbientInfluence );
	
	lowp vec3 color = ( diffuseCol.rgb * mix( lightAmb, lightDiffuse[0], lightDiffuseFactor ) ) * ColorScale;
	
#ifdef USE_SELF_ILLUM_MAP
	lowp vec3 specGlossSi = texture2D( specularGlossSelfIllumMap, vUV0 ).rgb;
#endif
	
#ifdef RIM_LIGHT
	lowp float fresnel = 1.0 - max( dot( normalize( vEyeDir ), normal ), 0.0 );
	color = mix( color, RimColor.rgb, pow( fresnel, RimPower ) * RimColor.a );
#endif

#ifdef USE_SELF_ILLUM_MAP
	color = mix( color, diffuseTexCol.rgb, specGlossSi.b );
#endif

#ifdef USE_FOG
	color = mix( color, fogColor.rgb, vFogFactor * FogInfluence );
#endif
	
	lowp vec4 finalColor = vec4( color, diffuseCol.a * AlphaScale );
	
#ifdef BURNING_MAP
	lowp float fireFactor = BurningThreshold - burningAlpha;
	lowp float burningMixFactor = max( 0.1 - fireFactor, 0.0 ) * 10.0;
	finalColor.rgb = mix( finalColor.rgb, FireColor, burningMixFactor );
#endif
	
	gl_FragColor = finalColor;
}
