//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform highp mat4 worldMatrix;
uniform highp mat4 worldViewProjMatrix;

#if defined( USE_FOG ) || defined( DUAL_PARABOLOID_PROJECTION )
uniform highp mat4 worldViewMatrix;
#endif

#ifdef AMBIENT_MAP
uniform highp mat4 ambientMapVPMatrix;
#endif

#ifdef USE_FOG
uniform lowp vec4 fogColor;
uniform lowp float fogStart;
uniform lowp float fogRangeI;
#endif

#ifdef DUAL_PARABOLOID_PROJECTION
uniform lowp float cameraFar;
#endif

#ifdef SHADOW_MAP
uniform highp mat4 shadowMapVPMatrix;
#endif

uniform lowp vec2 DiffuseMapUVScale;
uniform lowp vec2 DiffuseMapUVOffset;

attribute vec4 inPos;
attribute vec4 inNormal;
attribute vec2 inUV0;

#ifdef LIGHT_MAP
attribute vec2 inUV1;
#endif

varying highp vec3 vNormal;

varying highp vec3 vLightDir;
varying highp vec2 vUV0;

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

#ifdef SHADOW_MAP
varying highp vec3 vPosShadowMapSpace;
#endif

#ifdef AMBIENT_MAP
varying lowp vec2 vPosAmbientMapSpace;
#endif

#ifdef SHADOW_BLOB
varying highp vec3 vPosWS;
#endif

#ifdef LIGHT_MAP
varying lowp vec2 vUV1;
#endif

#ifdef DUAL_PARABOLOID_PROJECTION
#include "paraboloid_project.glsl"
#endif

void main()
{	
	highp vec4 posOS = vec4( inPos.xyz, 1.0 );
	highp vec4 posWS = worldMatrix * posOS;
	
	vNormal = vec3( worldMatrix * vec4( inNormal.xyz, 0.0 ) );
	
	vUV0 = inUV0 * DiffuseMapUVScale + DiffuseMapUVOffset;
	
#ifdef LIGHT_MAP
	vUV1 = inUV1;
#endif
	
#ifdef USE_FOG
	lowp float vertDepth = -( worldViewMatrix * posOS ).z;
	lowp float fog = clamp( ( vertDepth - fogStart ) * fogRangeI, 0.0, 1.0 );
	vFogFactor = fog * fogColor.a;
#endif

#ifdef SHADOW_MAP
	vPosShadowMapSpace = vec3( shadowMapVPMatrix * posWS );
#endif

#ifdef AMBIENT_MAP
	vPosAmbientMapSpace = vec2( ambientMapVPMatrix * posWS );
#endif
	
#ifdef SHADOW_BLOB
	vPosWS = posWS.xyz;
#endif

#ifndef DUAL_PARABOLOID_PROJECTION
	gl_Position = worldViewProjMatrix * posOS;
#else
	gl_Position = ParaboloidProject( worldViewMatrix * posOS, cameraFar );
#endif
}