//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform lowp float ColorScale;
uniform lowp float AlphaScale;
uniform lowp float AmbientInfluence;
uniform lowp float MaxDiffuse;
uniform lowp vec4 TintColor;

#ifdef ENVIRONMENT_MAPPING
uniform highp mat4 paraboloidViewMatrix;
#endif

uniform lowp vec3 lightDiffuse[MAX_LIGHTS];
uniform lowp vec3 lightPos[MAX_LIGHTS];

#ifndef AMBIENT_MAP
uniform lowp vec3 lightAmbient[MAX_LIGHTS];
#endif

#ifdef USE_SPEC
uniform lowp float SpecularPower;

	#ifndef USE_SPECULAR_MAP
	uniform lowp float SpecularIntensity;
	#endif

uniform lowp vec3 SpecularColor;
#endif

#ifdef USE_FOG
uniform lowp vec4 fogColor;
uniform lowp float FogInfluence;
#endif

#ifdef ENVIRONMENT_MAPPING
	
	uniform lowp float Reflectance;

uniform lowp float ReflectionContrast;
#endif

uniform sampler2D diffuseMap;

#ifdef AMBIENT_MAP
uniform sampler2D ambientMap;
#endif

#if defined( USE_SPECULAR_MAP ) || defined( USE_GLOSS_MAP )
uniform sampler2D specularGlossSelfIllumMap;
#endif

#ifdef ENVIRONMENT_MAPPING
uniform sampler2D environmentMap;
#endif

varying highp vec3 vNormal;

varying highp vec2 vUV0;

#if defined( USE_SPEC ) || defined( ENVIRONMENT_MAPPING )
varying highp vec3 vEyeDir;
#endif

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

#ifdef AMBIENT_MAP
varying lowp vec2 vPosAmbientMapSpace;
#endif

#ifdef ENVIRONMENT_MAPPING
const lowp vec3 k_colorWeights = vec3( 0.2126, 0.7152, 0.0722 );
#endif

#ifdef ENVIRONMENT_MAPPING
#include "paraboloid_project_uv.glsl"
#endif

void main()
{

	lowp vec4 diffuseCol = jetAlphaTexture2D( diffuseMap, vUV0 ) * TintColor;
	
	highp vec3 normal = normalize( vNormal );
	
	lowp vec3 lightDir = normalize( lightPos[0] );
	lowp float NdotL = dot( normal, lightDir );
	
	lowp float diffuseIntensity = max( NdotL, 0.0 );

#ifdef AMBIENT_MAP
	lowp vec3 lightAmb = texture2D( ambientMap, vPosAmbientMapSpace ).rgb;
#else
	lowp vec3 lightAmb = lightAmbient[0];
#endif

	diffuseIntensity *= MaxDiffuse;
	lowp float lightDiffuseFactor = mix( 1.0, diffuseIntensity, AmbientInfluence );
	
	lowp vec3 color = ( diffuseCol.rgb * mix( lightAmb, lightDiffuse[0], lightDiffuseFactor ) ) * ColorScale;
	
#if defined( USE_SPECULAR_MAP ) || defined( USE_GLOSS_MAP )
	lowp vec3 specGlossSi = texture2D( specularGlossSelfIllumMap, vUV0 ).rgb;
#endif
	
#ifdef USE_SPEC
	lowp vec3 specColor = vec3( 0.0, 0.0, 0.0 );
	if( NdotL > 0.0 )
	{
		lowp vec3 reflectDir = reflect( -lightDir, normal );
		lowp float factor = max( dot( normalize( vEyeDir ), reflectDir ), 0.0 );
	
	#ifdef USE_SPECULAR_MAP
		lowp float specIntensity = specGlossSi.r;
	#else
		lowp float specIntensity = SpecularIntensity;
	#endif
	
	#ifdef USE_GLOSS_MAP
		lowp float specPow = specGlossSi.g * SpecularPower;
	#else
		lowp float specPow = SpecularPower;
	#endif
	
		specColor = max( SpecularColor * specIntensity * pow( factor, specPow ), 0.0 );
	}
	
	color += specColor;
#endif

#ifdef ENVIRONMENT_MAPPING
	lowp vec3 reflectDir = reflect( normalize( -vEyeDir ), normal );
	lowp vec2 reflectUV = ParaboloidProjectUV( vec3( paraboloidViewMatrix * vec4( reflectDir, 0.0 ) ) );
	lowp vec3 envMapCol = texture2D( environmentMap, reflectUV ).rgb;
	lowp float reflectBrightness = dot( envMapCol, k_colorWeights );
	lowp vec3 reflectCol = mix( vec3( reflectBrightness ), envMapCol, ReflectionContrast );
	
		color = mix( color, reflectCol, Reflectance );
#endif
	
#ifdef USE_FOG
	color = mix( color, fogColor.rgb, vFogFactor * FogInfluence );
#endif
	
	lowp vec4 finalColor = vec4( color, diffuseCol.a * AlphaScale );
	
	gl_FragColor = finalColor;
}
