//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform highp mat4 worldMatrix;
uniform highp mat4 worldViewProjMatrix;

#if defined( USE_FOG ) || defined( DUAL_PARABOLOID_PROJECTION )
uniform highp mat4 worldViewMatrix;
#endif

#if defined( USE_SPEC ) || defined( RIM_LIGHT )
	#ifdef MODEL_USE_MEDIUMP_CAMERAPOS
uniform mediump vec3 cameraPos;
	#else
uniform lowp vec3 cameraPos;
	#endif
#endif

#ifdef USE_FOG
uniform mediump vec4 fogColor;
uniform lowp float fogStart;
uniform lowp float fogRangeI;
#endif

#ifdef DUAL_PARABOLOID_PROJECTION
uniform lowp float cameraFar;
#endif

uniform lowp vec2 DiffuseMapUVScale;
uniform lowp vec2 DiffuseMapUVOffset;

attribute vec4 inPos;
attribute vec4 inNormal;
attribute vec2 inUV0;

#ifdef VERTEX_COLOR
attribute vec4 inColor;
#endif

varying highp vec3 vNormal;

varying highp vec3 vLightDir;
varying highp vec2 vUV0;

#if defined( USE_SPEC ) || defined( RIM_LIGHT )
varying highp vec3 vEyeDir;
#endif

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

#ifdef VERTEX_COLOR
varying lowp vec4 vColor;
#endif

#ifdef DUAL_PARABOLOID_PROJECTION
#include "paraboloid_project.glsl"
#endif

void main()
{	
	highp vec4 posOS = vec4( inPos.xyz, 1.0 );
	highp vec4 posWS = worldMatrix * posOS;
	
	vNormal = vec3( worldMatrix * vec4( inNormal.xyz, 0.0 ) );
	
	vUV0 = inUV0 * DiffuseMapUVScale + DiffuseMapUVOffset;
	
#ifdef VERTEX_COLOR
	vColor = inColor;
#endif
	
#if defined( USE_SPEC ) || defined( RIM_LIGHT )
	vEyeDir = cameraPos - posWS.xyz;
#endif
	
#ifdef USE_FOG
	lowp float vertDepth = -( worldViewMatrix * posOS ).z;
	lowp float fog = clamp( ( vertDepth - fogStart ) * fogRangeI, 0.0, 1.0 );
	vFogFactor = fog * fogColor.a;
#endif

#ifndef DUAL_PARABOLOID_PROJECTION
	gl_Position = worldViewProjMatrix * posOS;
#else
	gl_Position = ParaboloidProject( worldViewMatrix * posOS, cameraFar );
#endif
}