//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform lowp float ColorScale;
uniform lowp float AlphaScale;
uniform lowp float AmbientInfluence;
uniform lowp float MaxDiffuse;
uniform lowp vec4 TintColor;

uniform lowp vec3 lightDiffuse[MAX_LIGHTS];
uniform lowp vec3 lightPos[MAX_LIGHTS];

uniform lowp vec3 lightAmbient[MAX_LIGHTS];

#ifdef USE_SPEC
uniform lowp float SpecularPower;

	#ifndef USE_SPECULAR_MAP
	uniform lowp float SpecularIntensity;
	#endif

uniform lowp vec3 SpecularColor;
#endif

#ifdef USE_FOG
uniform mediump vec4 fogColor;
uniform lowp float FogInfluence;
#endif

#ifdef BURNING_MAP
uniform lowp float BurningThreshold;
uniform lowp vec3 FireColor;
#endif

#ifdef RIM_LIGHT
uniform lowp float RimPower;
uniform lowp vec4 RimColor;
#endif

uniform sampler2D diffuseMap;

#if defined( USE_SPECULAR_MAP ) || defined( USE_GLOSS_MAP )
uniform sampler2D specularGlossSelfIllumMap;
#endif

#ifdef BURNING_MAP
uniform sampler2D burningMap;
#endif

varying highp vec3 vNormal;

varying highp vec2 vUV0;

#if defined( USE_SPEC ) || defined( RIM_LIGHT )
varying highp vec3 vEyeDir;
#endif

#ifdef USE_FOG
varying lowp float vFogFactor;
#endif

#ifdef VERTEX_COLOR
varying lowp vec4 vColor;
#endif

void main()
{
#ifdef BURNING_MAP
	lowp float burningAlpha = texture2D( burningMap, vUV0 ).r;
	if( burningAlpha > BurningThreshold )
		discard;
#endif

		lowp vec4 diffuseCol = jetAlphaTexture2D( diffuseMap, vUV0 ) * TintColor;

#ifdef VERTEX_COLOR
	diffuseCol *= vColor;
#endif
	
	highp vec3 normal = normalize( vNormal );
	
	lowp vec3 lightDir = normalize( lightPos[0] );
	lowp float NdotL = dot( normal, lightDir );
	
	lowp float diffuseIntensity = max( NdotL, 0.0 );

	lowp vec3 lightAmb = lightAmbient[0];

	diffuseIntensity *= MaxDiffuse;
	lowp float lightDiffuseFactor = mix( 1.0, diffuseIntensity, AmbientInfluence );
	
	lowp vec3 color = ( diffuseCol.rgb * mix( lightAmb, lightDiffuse[0], lightDiffuseFactor ) ) * ColorScale;
	
#if defined( USE_SPECULAR_MAP ) || defined( USE_GLOSS_MAP )
	lowp vec3 specGlossSi = texture2D( specularGlossSelfIllumMap, vUV0 ).rgb;
#endif
	
#ifdef USE_SPEC
	lowp vec3 specColor = vec3( 0.0, 0.0, 0.0 );
	if( NdotL > 0.0 )
	{
		lowp vec3 reflectDir = reflect( -lightDir, normal );
		lowp float factor = max( dot( normalize( vEyeDir ), reflectDir ), 0.0 );
	
	#ifdef USE_SPECULAR_MAP
		lowp float specIntensity = specGlossSi.r;
	#else
		lowp float specIntensity = SpecularIntensity;
	#endif
	
	#ifdef USE_GLOSS_MAP
		lowp float specPow = specGlossSi.g * SpecularPower;
	#else
		lowp float specPow = SpecularPower;
	#endif
	
		specColor = max( SpecularColor * specIntensity * pow( factor, specPow ), 0.0 );
	}
	
	color += specColor;
#endif

#ifdef RIM_LIGHT
	lowp float fresnel = 1.0 - max( dot( normalize( vEyeDir ), normal ), 0.0 );
	color = mix( color, RimColor.rgb, pow( fresnel, RimPower ) * RimColor.a );
#endif

#ifdef USE_FOG
	color = mix( color, fogColor.rgb, vFogFactor * FogInfluence );
#endif
	
	lowp vec4 finalColor = vec4( color, diffuseCol.a * AlphaScale );
	
#ifdef BURNING_MAP
	lowp float fireFactor = BurningThreshold - burningAlpha;
	lowp float burningMixFactor = max( 0.1 - fireFactor, 0.0 ) * 10.0;
	finalColor.rgb = mix( finalColor.rgb, FireColor, burningMixFactor );
#endif
	
	gl_FragColor = finalColor;
}
