//
// THIS FILE IS GENERATED AUTOMATICALLY, DO NOT CHANGE IT BY HAND!
//


uniform lowp float ColorScale;
uniform lowp float AlphaScale;
uniform lowp float AmbientInfluence;
uniform lowp float MaxDiffuse;
uniform lowp vec4 TintColor;

uniform lowp vec3 lightDiffuse[MAX_LIGHTS];
uniform lowp vec3 lightPos[MAX_LIGHTS];

uniform mediump vec2 gReflectionParams;


uniform lowp vec3 lightAmbient[MAX_LIGHTS];

#ifdef RIM_LIGHT

	uniform lowp float 		RimPower;
	uniform lowp vec4 		RimColor;

#endif

#ifdef PULSING_BRIGHTNESS

	uniform highp float 	wrapTime;
	uniform lowp vec4 		PulsingColor;
	uniform lowp float 		PulsingSpeed;

#endif

	uniform sampler2D diffuseMap;

	uniform sampler2D matcapMap;

	uniform lowp float MatcapFactor;

	varying highp vec3 vNormal;
	varying highp vec2 vUV0;

#ifdef RIM_LIGHT

	varying highp vec3 vEyeDir;

#endif

#ifdef PULSING_BRIGHTNESS

	const highp float k_pi = 3.1415926;
	const highp float k_2pi = k_pi * 2.0;

#endif

varying highp vec3 		vPositionWS;


varying mediump vec3 	vViewEye;
varying mediump vec3 	vViewNrm;


highp vec2 matcap(highp vec3 eye, highp vec3 normal)
{
	highp vec3 reflected = reflect(eye, normal);
	highp float m = 2.8284271247461903 * sqrt( reflected.z+1.0 );
	reflected.xy = reflected.xy / m + 0.5;
	return vec2(reflected.x,1.0 - reflected.y);
}

void main()
{

	lowp vec4 diffuseCol = jetAlphaTexture2D( diffuseMap, vUV0 );
	diffuseCol *= TintColor;
	
	highp vec3 normal = normalize( vNormal );
	
	lowp vec3 lightDir = normalize( lightPos[0] );
	lowp float NdotL = dot( normal, lightDir );
	
	lowp float diffuseIntensity = max( NdotL, 0.0 );

	lowp vec3 lightAmb = vec3(1.0);//lightAmbient[0];

	diffuseIntensity *= MaxDiffuse;

	lowp float lightDiffuseFactor =  mix( 1.0, diffuseIntensity, AmbientInfluence );
	
	lowp vec3 color = ( diffuseCol.rgb *  mix( lightAmb, lightDiffuse[0], lightDiffuseFactor ) ) * ColorScale;
	
#ifdef RIM_LIGHT

	lowp float fresnel = 1.0 - max( dot( normalize( vEyeDir ), normal ), 0.0 );
	color = mix( color, RimColor.rgb, pow( fresnel, RimPower ) * RimColor.a );

#endif

	lowp vec3 refl_matcap = texture2D(matcapMap,matcap(normalize(vViewEye),normalize(vViewNrm))).rgb;

	color.rgb = mix(color.rgb,refl_matcap.rgb,diffuseCol.a * MatcapFactor);

#ifdef PULSING_BRIGHTNESS

	// clamp driver wraptime to 0..2pi
	highp float factor = ( wrapTime / 30.0 ) * k_2pi;
	highp float pulsingSpeed = floor( PulsingSpeed ) * 3.0;		// adjusting pulsing speed (will fix this in future via clara parameters)
	color += PulsingColor.rgb * ( sin( factor * pulsingSpeed ) + 1.0 ) * 0.5;

#endif

	lowp vec4 finalColor = vec4( color, diffuseCol.a * AlphaScale );

	//reflection falloff
	highp float fdistance = -vPositionWS.z;//distance on direction vector
	fdistance = min(gReflectionParams.x,fdistance);//clamp to max fdistance->[-inf,distance]
	fdistance = fdistance - gReflectionParams.x;//[-inf to 0]
	fdistance = 1.0 - exp (gReflectionParams.y * fdistance);//(fdistance < 0) -> exp -> (0,1]

	finalColor.a *= fdistance;
	
	gl_FragColor = finalColor;
}