uniform sampler2D diffuseMap;
uniform lowp vec3 TintColor;
uniform lowp float alphaScale;

varying highp vec2 uvMov;
varying lowp vec4 VC;

#ifdef ADDITIONAL_COLOR
uniform lowp vec3 AdditionalColor;
#endif

void main()
{							
	lowp vec4 DF = texture2D( diffuseMap, uvMov );
	lowp vec4 finalColor = DF * vec4( TintColor, 1.0) ;

#ifdef ADDITIONAL_COLOR
	finalColor += vec4( AdditionalColor.rgb, 0.0 );
#endif
	
	gl_FragColor = vec4( finalColor.rgb, 1.0 ) * alphaScale;
}
