uniform sampler2D diffuse1Map_a_l_p_h_a;

uniform sampler2D diffuseMap;
uniform lowp vec3 TintColor;
uniform lowp float alphaScale;

varying highp vec2 uvMov;
varying lowp vec4 VC;

#ifdef RIM_LIGHT
uniform lowp float RimPower;
uniform lowp vec4 RimColor;

varying highp vec3 vNormal;
varying highp vec3 vEyeDir;
#endif

void main()
{							
	lowp vec4 DF 	   = (texture2D(diffuseMap, uvMov)* vec4(vec3(1.0), texture2D(diffuse1Map_a_l_p_h_a, uvMov).r));
	lowp vec4 finalColor = ((DF) * 0.5) * vec4(TintColor,1.0);

#ifdef RIM_LIGHT
	lowp float fresnel = 1.0 - max( dot( normalize( vEyeDir ), normalize( vNormal ) ), 0.0 );
	finalColor = vec4( mix( finalColor.rgb, RimColor.rgb, pow( fresnel, RimPower ) * RimColor.a ), 1.0);
#endif
	
	gl_FragColor = vec4( finalColor.rgb, 1.0 ) * alphaScale;
}
