attribute vec4 inPos;
attribute vec2 inTexCoords0;
attribute vec4 inColors;
attribute vec4 inNormal;

uniform highp 	float inTime;

uniform	mediump float X_speed;
uniform mediump float Y_speed;

uniform mediump float uvMultiplier;				

uniform highp mat4 inWorldMatrix;
uniform highp mat4 inWorldViewProjMatrix;
			
#ifdef RIM_LIGHT
uniform lowp vec3 inCameraPos;
varying highp vec3 vEyeDir;
varying highp vec3 vNormal;
#endif

varying highp vec2 uvMov;
varying lowp vec4  VC;
				
void main()
{				
	 
	highp vec4 vPos = inWorldViewProjMatrix * vec4(inPos.xyz, 1.0);
	gl_Position = vPos;
	
#ifdef RIM_LIGHT
		vNormal = inNormal.xyz;
		vEyeDir = inCameraPos - inPos.xyz;	
#endif
	
	highp vec2 xyCoord = fract(vec2(inTime*(X_speed*0.1), inTime*(Y_speed*0.1)));
	
	uvMov = inTexCoords0 * uvMultiplier + xyCoord;	
	VC = inColors;
}