varying mediump		vec2 		uv;
varying lowp 		vec4 		color;
uniform 			sampler2D 	texture0;
uniform lowp 		vec3 		whiteColorTo;
uniform lowp 		vec3 		blackColorTo;
uniform lowp 		float		fadeCoefficient;

#ifdef COMPUTE_LINEAR_DEPTH
varying mediump 	vec3 		positionWorldSpace;
uniform mediump 	vec4 		inLinearDepthPlane;
#endif

#ifdef COLOR_CORRECTION
uniform lowp 		mat4 		colorcorrectionmatrix;
#endif

void main()
{
#ifdef COMPUTE_LINEAR_DEPTH
	#define gl_FragColor gl_FragData[0]
#endif
	lowp vec4 texColor0 = jetAlphaTexture2D(texture0, uv);
	
	texColor0.a = texColor0.r * fadeCoefficient;
	
	texColor0.rgb = mix( blackColorTo, whiteColorTo, texColor0.rgb );
	lowp vec4 finalColor = texColor0 * color;

	
#ifdef COLOR_CORRECTION
	finalColor.rgb = clamp(colorcorrectionmatrix*finalColor,vec4(0),vec4(1)).rgb;
#endif
	
	gl_FragColor = finalColor;
	
#if defined(COMPUTE_LINEAR_DEPTH)
	gl_FragData[1] = vec4( dot( vec4( positionWorldSpace.xyz, 1.0), inLinearDepthPlane ) );
#endif
}
