uniform highp	mat4 inWorldMatrix;
uniform highp	mat4 inWorldViewProjMatrix;

attribute 		vec4 	inPos;
attribute 		vec2 	inUV0;
attribute 		vec4	inColor;
varying lowp 	vec4 	color;
varying mediump vec2 	uv;

#ifdef COMPUTE_LINEAR_DEPTH
varying highp 	vec3 	positionWorldSpace;
#endif

void main()
{
	gl_Position = inWorldViewProjMatrix * vec4(inPos.xyz, 1.0);
	color = inColor;
	uv = inUV0;
	
#ifdef COMPUTE_LINEAR_DEPTH
	highp vec4 posWS = ( inWorldMatrix * vec4( inPos.xyz, 1.0 ) );
	positionWorldSpace = posWS.xyz;
#endif
}