uniform highp mat4 projMatrix;
uniform highp mat4 worldViewMatrix;
uniform highp mat4 worldViewProjMatrix;
uniform highp mat4 worldViewITMatrix;

attribute vec4 inPos;
attribute vec4 inNormal;

void main()
{
	vec4 outPos = worldViewProjMatrix * inPos;
	vec4 norm = worldViewITMatrix * inNormal;
	norm.x *= projMatrix[0][0];
	norm.y *= projMatrix[1][1];
	outPos.xy += norm.xy * outPos.z * 0.004;
	gl_Position = outPos;
}