
#include "tex_compare.glsl"

lowp float texture2DPCF( sampler2D shadowMap, lowp vec2 shadowMapSize, lowp vec2 uv, lowp float refVal )
{
	lowp vec2 texelSize = 1.0 / shadowMapSize;
	lowp vec2 shadowMapSizePS = uv * shadowMapSize + 0.5; 
	lowp vec2 factors = fract( shadowMapSizePS );
	lowp vec2 uvCentered = floor( shadowMapSizePS ) / shadowMapSize;
	
	lowp float v00 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -2.0, 2.0 ), refVal );
	lowp float v10 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, 2.0 ), refVal );
	lowp float v20 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, 2.0 ), refVal );
	lowp float v30 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, 2.0 ), refVal );
	lowp float v40 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 2.0, 2.0 ), refVal );
	
	lowp float v01 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -2.0, 1.0 ), refVal );
	lowp float v11 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, 1.0 ), refVal );
	lowp float v21 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, 1.0 ), refVal );
	lowp float v31 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, 1.0 ), refVal );
	lowp float v41 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 2.0, 1.0 ), refVal );
	
	lowp float v02 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -2.0, 0.0 ), refVal );
	lowp float v12 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, 0.0 ), refVal );
	lowp float v22 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, 0.0 ), refVal );
	lowp float v32 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, 0.0 ), refVal );
	lowp float v42 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 2.0, 0.0 ), refVal );
	
	lowp float v03 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -2.0, -1.0 ), refVal );
	lowp float v13 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, -1.0 ), refVal );
	lowp float v23 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, -1.0 ), refVal );
	lowp float v33 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, -1.0 ), refVal );
	lowp float v43 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 2.0, -1.0 ), refVal );
	
	lowp float v04 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -2.0, -2.0 ), refVal );
	lowp float v14 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, -2.0 ), refVal );
	lowp float v24 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, -2.0 ), refVal );
	lowp float v34 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, -2.0 ), refVal );
	lowp float v44 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 2.0, -2.0 ), refVal );

	lowp float p00 = mix( mix( v01, v00, factors.y ), mix( v11, v10, factors.y ), factors.x );
	lowp float p01 = mix( mix( v02, v01, factors.y ), mix( v12, v11, factors.y ), factors.x );
	lowp float p02 = mix( mix( v03, v02, factors.y ), mix( v13, v12, factors.y ), factors.x );
	lowp float p03 = mix( mix( v04, v03, factors.y ), mix( v14, v13, factors.y ), factors.x );
	
	lowp float p10 = mix( mix( v11, v10, factors.y ), mix( v21, v20, factors.y ), factors.x );
	lowp float p11 = mix( mix( v12, v11, factors.y ), mix( v22, v21, factors.y ), factors.x );
	lowp float p12 = mix( mix( v13, v12, factors.y ), mix( v23, v22, factors.y ), factors.x );
	lowp float p13 = mix( mix( v14, v13, factors.y ), mix( v24, v23, factors.y ), factors.x );
	
	lowp float p20 = mix( mix( v21, v20, factors.y ), mix( v31, v30, factors.y ), factors.x );
	lowp float p21 = mix( mix( v22, v21, factors.y ), mix( v32, v31, factors.y ), factors.x );
	lowp float p22 = mix( mix( v23, v22, factors.y ), mix( v33, v32, factors.y ), factors.x );
	lowp float p23 = mix( mix( v24, v23, factors.y ), mix( v34, v33, factors.y ), factors.x );
	
	lowp float p30 = mix( mix( v31, v30, factors.y ), mix( v41, v40, factors.y ), factors.x );
	lowp float p31 = mix( mix( v32, v31, factors.y ), mix( v42, v41, factors.y ), factors.x );
	lowp float p32 = mix( mix( v33, v32, factors.y ), mix( v43, v42, factors.y ), factors.x );
	lowp float p33 = mix( mix( v34, v33, factors.y ), mix( v44, v43, factors.y ), factors.x );

	return (	p00 + p01 + p02 + p03 +
				p10 + p11 + p12 + p13 +
				p20 + p21 + p22 + p23 +
				p30 + p31 + p32 + p33 ) / 16.0;
}