
#include "tex_compare.glsl"

lowp float texture2DPCF( sampler2D shadowMap, lowp vec2 shadowMapSize, lowp vec2 uv, lowp float refVal )
{
	lowp vec2 texelSize = 1.0 / shadowMapSize;
	lowp vec2 shadowMapSizePS = uv * shadowMapSize + 0.5; 
	lowp vec2 factors = fract( shadowMapSizePS );
	lowp vec2 uvCentered = floor( shadowMapSizePS ) / shadowMapSize;

    lowp float lb = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, 0.0 ), refVal );
    lowp float lt = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, 1.0 ), refVal );
    lowp float rb = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, 0.0 ), refVal );
    lowp float rt = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, 1.0 ), refVal );
	
	return mix( mix( lb, lt, factors.y ), mix( rb, rt, factors.y ), factors.x );
}