
#include "tex_compare.glsl"

lowp float texture2DPCF( sampler2D shadowMap, lowp vec2 shadowMapSize, lowp vec2 uv, lowp float refVal )
{
	lowp vec2 texelSize = 1.0 / shadowMapSize;
	lowp vec2 shadowMapSizePS = uv * shadowMapSize + 0.5; 
	lowp vec2 factors = fract( shadowMapSizePS );
	lowp vec2 uvCentered = floor( shadowMapSizePS ) / shadowMapSize;
	
	lowp float v00 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, 1.0 ), refVal );
	lowp float v10 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, 1.0 ), refVal );
	lowp float v20 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, 1.0 ), refVal );
	
	lowp float v01 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, 0.0 ), refVal );
	lowp float v11 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, 0.0 ), refVal );
	lowp float v21 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, 0.0 ), refVal );
	
	lowp float v02 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( -1.0, -1.0 ), refVal );
	lowp float v12 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 0.0, -1.0 ), refVal );
	lowp float v22 = texture2DCompare( shadowMap, uvCentered + texelSize * vec2( 1.0, -1.0 ), refVal );
	

	lowp float p00 = mix( mix( v01, v00, factors.y ), mix( v11, v10, factors.y ), factors.x );
	lowp float p01 = mix( mix( v02, v01, factors.y ), mix( v12, v11, factors.y ), factors.x );
	
	lowp float p10 = mix( mix( v11, v10, factors.y ), mix( v21, v20, factors.y ), factors.x );
	lowp float p11 = mix( mix( v12, v11, factors.y ), mix( v22, v21, factors.y ), factors.x );

	return ( p00 + p01 + p10 + p11 ) / 4.0;
}